<?php
include "inc/settings.inc.php";
include "classes/curl.class.php";
include "classes/request.class.php";	
include "classes/database.class.php";
include "classes/generic.class.php";

session_start();

if(isset($_SESSION['user_id']) && $_SESSION['user_id'] != false)
{
	$db = new Database();
	$gen = new Generic();
	$youless = $db->getYouLess($_SESSION['user_id']);
	$request = new Request($youless['0']);

	if(isset($_GET['a']) && $_GET['a'] == 'live')
	{
		echo $request->getLiveData($youless);
	}
	elseif(isset($_GET['a']) && $_GET['a'] == 'day' && isset($_GET['date']))
	{	
		
		$sqlDate = $_GET['date'];
		
		// Get data from specific day
		$rows = $db->getSpecificDay($sqlDate, $_SESSION['user_id']);
				
		if(count($rows) == 0)
		{
		
			echo '{"ok": 0, "msg":"Geen data beschikbaar op deze datum", "start": "'. $sqlDate .'", "val": " 0, 0", "kwh": 0, "price": 0}';
		
		}
		else
		{
			$youlessid = $rows[0]->youless_id;
			$i=0;
			$dataStr = '[{"'.$i.'":[';
			$previousTime = new DateTime($sqlDate.' 00:00:00');
			foreach($rows as $k)
			{
				if ($youlessid != $k->youless_id)
				{
					$dataStr .= ']},{"'.$i.'":[';
				}
				$difference = $previousTime->diff(new DateTime($k->time));
				if (($difference->format('%h') > 1) && ($youlessid == $k->youless_id))
				{
					$null = '" null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"';
					for ($j = 1; $j < ($difference->format('%h')); $j++)
					{
						$value .= ($j!=0 ? "," : "").$null;
					}
				}
				else
				{
					$value = $k->value;
				}
				$row = explode(",", $value);
				$previousTime = new DateTime($k->time);
				
				$dataStr .= ($i!=0 ? (substr($dataStr, -1)!='[' ? "," : "") : "").str_replace("\"", "", implode(",", $row));
				$i++;
				$youlessid = $k->youless_id;
			}
			
			// Output data
			echo '{"ok": 1, "start": "'. $sqlDate .'", "val": '. $dataStr .']}]}';	
		
		}
			
	}
	elseif(isset($_GET['a']) && $_GET['a'] == 'calculate_day' && isset($_GET['date']))
	{	
		
		$sqlDate = $_GET['date'];
		
		// Get data from specific day
		$costs = $gen->calculateDayKwhCosts($sqlDate);	
			
		// Output data
		echo '{"ok": 1, "kwh": "'. number_format($costs['kwh'], 2, ',', '') .'", "kwhLow": "'. number_format($costs['kwhLow'], 2, ',', '') .'", "price": "'. number_format($costs['price'], 2, ',', '') .'", "priceLow": "'. number_format($costs['priceLow'], 2, ',', '') .'"}';	
		
			
	}	
	elseif(isset($_GET['a']) && $_GET['a'] == 'week' && isset($_GET['date']))
	{	
		
		$sqlDate = $_GET['date'];
		
		$week = date('W',strtotime($sqlDate));
		$year = date('Y',strtotime($sqlDate));
	
		$begin = date("Y-m-d", strtotime($year."W".$week));
		$end = date("Y-m-d", strtotime($year."W".$week)+(6*86400));		
				
		// Get data from specific week
		$rows = $db->getSpecificRange($begin, $end, $_SESSION['user_id']);

		if(count($rows) == 0)
		{
		
			echo '{"ok": 0, "msg":"Geen data beschikbaar op deze datum", "start": "'. $begin .'", "val": " 0, 0", "kwh": 0, "price": 0}';
		
		}
		else
		{
				
			$i=0;
			$dataStr = '';
			$previousTime = new DateTime($begin.' 00:00:00');
			foreach($rows as $k)
			{
				$difference = $previousTime->diff(new DateTime($k->time));
				if ($difference->format('%h') > 1)
				{
					$null = '" null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"," null"';
					for ($j = 1; $j < ($difference->format('%h')); $j++)
					{
						$value .= ($j!=0 ? "," : "").$null;
					}
				}
				else
				{
					$value = $k->value;
				}
				$row = explode(",", $value);
				$previousTime = new DateTime($k->time);
				
				$dataStr .= ($i!=0 ? "," : "").str_replace("\"", "", implode(",", $row));
				
				$i++;
			}
			
			// Output data
			echo '{"ok": 1, "start": "'. $begin .'", "val": "'. $dataStr .'"}';	
		}
	}
	elseif(isset($_GET['a']) && $_GET['a'] == 'calculate_week' && isset($_GET['date']))
	{	
		
		$sqlDate = $_GET['date'];
		
		$week = date('W',strtotime($sqlDate));
		$year = date('Y',strtotime($sqlDate));
	
		$start = date("Y-m-d", strtotime($year."W".$week));
		$end = date("Y-m-d", strtotime($year."W".$week)+(6*86400));
		
		// Calculate totals/costs
		$costs = $gen->calculateRangeKwhCosts($start, $end);
		
		// Output data
		echo '{"ok": 1, "kwh": "'. number_format($costs['kwh'], 2, ',', '') .'", "kwhLow": "'. number_format($costs['kwhLow'], 2, ',', '') .'", "price": "'. number_format($costs['price'], 2, ',', '') .'", "priceLow": "'. number_format($costs['priceLow'], 2, ',', '') .'"}';	
	}	
	elseif(isset($_GET['a']) && $_GET['a'] == 'month' && isset($_GET['date']))
	{	
		
		$sqlDate = $_GET['date'];
		
		$month = date('m',strtotime($sqlDate));
		
		$data = $request->getSpecificMonth($month);	
		$values = explode('","', $data['val']);
		
		$begin = date("Y-m-d", strtotime($data['tm']));
		foreach($values as $k => $v)
		{
			$v = str_replace('"', '', $v);
			$values[$k] = str_replace(',','.',$v);
		}
		$dataStr = implode(',', $values);
		
		// Output data
		echo '{"ok": 1, "start": "'. $begin .'", "val": "'. $dataStr .'"}';	
	}	
	elseif(isset($_GET['a']) && $_GET['a'] == 'calculate_month' && isset($_GET['date']))
	{	
		
		$sqlDate = $_GET['date'];
		
		$month = date('m',strtotime($sqlDate));
		
		$start = date('Y-m',strtotime($sqlDate)).'-01';
		$end = date('Y-m-d', strtotime('-1 second', strtotime('+1 month', strtotime($start))));
				
		// Calculate totals/costs
		$costs = $gen->calculateRangeKwhCosts($start, $end);
		
		// Output data
		echo '{"ok": 1, "kwh": "'. number_format($costs['kwh'], 2, ',', '') .'", "kwhLow": "'. number_format($costs['kwhLow'], 2, ',', '') .'", "price": "'. number_format($costs['price'], 2, ',', '') .'", "priceLow": "'. number_format($costs['priceLow'], 2, ',', '') .'"}';	
	}	
	elseif(isset($_GET['a']) && $_GET['a'] == 'saveSettings')
	{
	
		$excludedFields = array(
			'password',
			'confirmpassword',
			'cpkwhlow_start_hour',
			'cpkwhlow_start_min',
			'cpkwhlow_end_hour',
			'cpkwhlow_end_min',
			'username'
		);
		
		foreach($_POST as $k => $v)
		{
			$$k = $v;
			if(!in_array($k, $excludedFields))
			{
				$db->updateSettings($k, $v, $_SESSION['user_id']);
			}
		}
		
		$cpkwhlow_start = $cpkwhlow_start_hour.":".$cpkwhlow_start_min;
		$cpkwhlow_end = $cpkwhlow_end_hour.":".$cpkwhlow_end_min;
		
		$db->updateSettings('cpkwhlow_start', $cpkwhlow_start, $_SESSION['user_id']);
		$db->updateSettings('cpkwhlow_end', $cpkwhlow_end, $_SESSION['user_id']);
		if ($username != "")
		{
			$db->updateUsername($username, $_SESSION['user_id']);
		}
	
		if($password != "" && $confirmpassword != "" && $password == $confirmpassword)
		{
			$db->updateLogin(sha1($password), $_SESSION['user_id']);
		}
		
		echo '{"ok": 0, "msg":"Instellingen succesvol opgeslagen"}';	
		
	}
	elseif(isset($_GET['a']) && $_GET['a'] == 'saveYouless')
	{
		$error = 0;
		if (!isset($_POST['friendly_name']) || $_POST['friendly_name'] == "")
		{
			$error = 1;
			$msg = 'Geen naam opgegeven ';	
		}
		if (!isset($_POST['YL_address']) || $_POST['YL_address'] == "")
		{
			$error = 1;
			$msg .= 'Geen youless adres opgegeven ';	
		}
		if (!isset($_POST['YL_port']) || $_POST['YL_port'] == "")
		{
			$error = 1;
			$msg .= 'Geen youless poort opgegeven ';	
		}
		if ($error == 1)
		{
			echo '{"ok": 0, "msg":"'.$msg.'"}';
			exit;
		}
		$db->updateYouLess($_SESSION['user_id'],$_POST['friendly_name'],$_POST['YL_address'],$_POST['YL_port'],$_POST['YL_password']);
		echo '{"ok": 0, "msg":"Instellingen succesvol opgeslagen"}';	
	}
	else
	{
		echo "Error!";
	}
}
else
{
	echo "Login required!";
}
?>