<?php

class Generic {

	
    /**
     * Create selector
     */
	public function selector($name, $selected, $options){
		$html = "<select name='".$name."'>\n";
		
		foreach($options as $k => $v) 
		{
			$html .= "<option value='" . $k . "'" . ($k==$selected?" selected":"") . ">$v</option>\n";
		}
		
		$html .= "</select>\n";
		
		return $html;
	}

    /**
     * Create selector
     */
	public function selectYouLess($name, $selected, $options){
		$html = "<select name='".$name."' size='4' width='250px' style='width: 250px;'>\n";

		foreach($options as $k => $v) 
		{
			$html .= "<option value='" . $v['youless_id'] . "'" . ($v['youless_id']==$selected?" selected":"") . ">".$v['friendly_name']."</option>\n";
		}
		
		$html .= "</select>\n";
		
		return $html;
	}
    /**
     * Create selector
     */
	public function selectSupplier($name, $selected, $options){
		$html = "<select name='".$name."' class='".$name."'>\n";
		$html .= "<option value='0'" . ($k==$selected?" selected='selected'":"") . " disabled='disabled'>-- Selecteer --</option>\n";
		foreach($options as $k => $v) 
		{
				$html .= "<option value='" . $v['id'] . "'" . ($v['id']==$selected?" selected":"") . ">".$v['name']."</option>\n";
		}
		
		$html .= "</select>\n";
		
		return $html;
	}

    /**
     * Create selector
     */
	public function selectPackage($name, $selected, $options){
		$html = "<option value='0'" . ($k==$selected?" selected='selected'":"") . " disabled='disabled'>-- Selecteer --</option>\n";
		foreach($options as $k => $v) 
		{
				$html .= "<option value='" . $v['id'] . "'" . ($v['id']==$selected?" selected":"") . ">".$v['package_name']."</option>\n";
		}
		return $html;
	}
    /**
     * Create time selector
     */
	public function timeSelector($selectedHour, $selectedMin, $prefix){
		$html = "<select name='".$prefix."_hour'>\n";
		for ($i=0;$i<24;$i++) 
		{
			$html .= "<option value='" . sprintf("%02d", $i) . "'" . ($i==$selectedHour?" selected='selected'":"") . ">$i</option>\n";
		}
		$html .= "</select>:<select name='".$prefix."_min'>\n";
		for ($i=0;$i<60;$i+=5) 
		{
			$html .= "<option value='" . sprintf("%02d", $i) . "'" . ($i==$selectedMin?" selected='selected'":"") . ">" . sprintf("%02d", $i) . "</option>\n";
		}
		$html .= "</select>";
		
		return $html;
	}
	
    /**
     * Calculate kwhs and costs for a range of days
     */	
     public function calculateRangeKwhCosts($beginDate, $endDate){
     	 
		$checkDate = $beginDate;  
		$data = array(
			'kwh' => 0,
			'kwhLow' => 0,
			'price' => 0,
			'priceLow' => 0
		);
			
		while ($checkDate != $endDate) { 

	
			$dailyData = $this->calculateDayKwhCosts($checkDate); 
			
			$data['kwh'] += $dailyData['kwh'];
			$data['kwhLow'] += $dailyData['kwhLow'];	
			$data['price'] += $dailyData['price'];
			$data['priceLow'] += $dailyData['priceLow'];			
			
			$checkDate = date ("Y-m-d", strtotime ("+1 day", strtotime($checkDate))); 
			
		}
		
		return $data;	
		  
     }
     
   /**
     * Calculate kwhs and costs for specific day
     */	
     public function calculateDayKwhCosts($checkDate){
     	
     	$this->db = new Database();
     	$settings = $this->db->getSettings($_SESSION['user_id']);
	
		if($settings['dualcount'] == 1)
		{
			$beginData = $this->db->getKwhCount($checkDate.' 00:00:00', $_SESSION['user_id']);
			$endData = $this->db->getKwhCount($checkDate.' 23:59:00', $_SESSION['user_id']);
			
			$beginLowData = $this->db->getKwhCount($checkDate.' '.$settings['cpkwhlow_start'].':00', $_SESSION['user_id']);
			$endLowData = $this->db->getKwhCount($checkDate.' '.$settings['cpkwhlow_end'].':00', $_SESSION['user_id']);			
			
			$timeStart = (int)str_replace(":","", $settings['cpkwhlow_start']);
			$timeEnd = (int)str_replace(":","", $settings['cpkwhlow_end']);
						
			if($timeStart > $timeEnd)
			{
				$kwh = str_replace(",",".", $beginLowData->kwh) - str_replace(",",".", $endLowData->kwh);
				$kwhLow = (str_replace(",",".", $endData->kwh) - str_replace(",",".", $beginData->kwh)) - $kwh;
			}
			else
			{
				$kwhLow = str_replace(",",".", $endLowData->kwh) - str_replace(",",".", $beginLowData->kwh);
				$kwh = (str_replace(",",".", $endData->kwh) - str_replace(",",".", $beginData->kwh)) - $kwhLow;			
			}
			
			// Calculate price
			$price = $kwh * (float)$settings['cpkwh'];
			$priceLow = $kwhLow * (float)$settings['cpkwh_low'];	
			
			$data = array();
			
			$data['kwh'] = $kwh;
			$data['kwhLow'] = $kwhLow;	
			$data['price'] = $price;
			$data['priceLow'] = $priceLow;				
		}
		else
		{
			$beginData = $this->db->getKwhCount($checkDate.' 00:00:00', $_SESSION['user_id']);
			$endData = $this->db->getKwhCount($checkDate.' 23:59:00', $_SESSION['user_id']);
			
			$kwh = str_replace(",",".", $endData->kwh) - str_replace(",",".", $beginData->kwh);
			
			// Calculate price
			$price = $kwh * (float)$settings['cpkwh'];
			
			$data = array();
			
			$data['kwh'] = $kwh;
			$data['kwhLow'] = 0;	
			$data['price'] = $price;
			$data['priceLow'] = 0;				
		}   		
		
		return $data;		  
     }     
     
}

?>